package eu.etaxonomy.taxeditor.navigation.navigator;

import java.util.Comparator;

import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerComparator;

import eu.etaxonomy.cdm.model.taxon.Classification;
import eu.etaxonomy.cdm.model.taxon.TaxonNaturalComparator;
import eu.etaxonomy.cdm.model.taxon.TaxonNode;

public class TaxonNodeNavigatorComparator extends ViewerComparator{

	
	public TaxonNodeNavigatorComparator(Comparator<TaxonNode> comparator){
		super(comparator);
	}

	
	
	@Override
	public int compare(Viewer viewer, Object e1, Object e2){
		if (e1 instanceof Classification && e2 instanceof Classification){
			return ((Classification)e1).getTitleCache().compareTo(((Classification)e2).getTitleCache());
		} else{
			if (this.getComparator() instanceof TaxonNaturalComparator){
				return this.getComparator().compare((TaxonNode)e1, (TaxonNode)e2);
			}else{
				return this.getComparator().compare(e1,e2);
			}
		}
	}
}
